 (**********************************)
 (* VRg MIDI Music System 1.12     *)
 (* General MIDI events definition *)
 (**********************************)

 (* Common MIDI events *)          (* Respective data *)

 const NOTE_OFF            = $80;  (* Note number, velocity *)
       NOTE_ON             = $90;  (* Note number, velocity *)
       KEY_AFTER_TOUCH     = $A0;  (* Note number, velocity *)
       CONTROL_CHANGE      = $B0;  (* Controller number, new value *)
       PATCH_CHANGE        = $C0;  (* New instrument number *)
       CHANNEL_AFTER_TOUCH = $D0;  (* Velocity *)
       PITCH_WHEEL         = $E0;  (* Least 7 bits, most 7 bits *)

 (* System exclusive messages *)

       SYS_EX              = $F0;
       SYS_EX_             = $F7;

 (* Meta-events *)

       META_EVENT          = $FF;

 (* Some meta-event types *)

       CHANNEL_PREFIX      = $20;  (* channel number *)
       END_OF_TRACK        = $2F;
       SET_TEMPO           = $51;  (* 24-bit us per quarter *)
       SMPTE_OFFSET        = $54;  (* hr, min, sec, frame, frame fraction *)
       TIME_SIGNATURE      = $58;  (* numerator, denominator *)
       KEY_SIGNATURE       = $59;  (* flat/sharp, major/minor *)
       SEQ_SPECIFIC        = $7F;

