(****************************************)
(* VRg MIDI Music System core v. 1.12   *)
(* (C) 1998-1999 Virtual Research       *)
(* Unit version : 1.12                  *)
(* Last updated : 21.Nov.1999           *)
(****************************************)

{$IFDEF _DYNAMIC}
 {$IFNDEF __TMT__}
  {$UNDEF _DYNAMIC}
 {$ENDIF}
{$ENDIF}

unit MIDInit;
{$I DEF32.INC}
{$I release.opt}

{$DEFINE _DEBUG}       (* Use this to allow _Debug MIDI device to be used *)

interface
uses VRMMSDef;

{$IFNDEF _DYNAMIC}
function MidiInit(Device:word):PMIDI;
 (* Initializes MIDI Music System *)
{$ELSE}
function MidiInit(Device:word;PathToDrivers:string):PMIDI;
 (* Initializes MIDI Music System with dynamic driver *)
procedure MidiShutDown;
 (* Shuts down MIDI Music System and unloads DLL *)
{$ENDIF}

implementation
{$IFNDEF _DYNAMIC}
uses
{$IFDEF _DEBUG}
 DbgMIDI,
{$ENDIF}
 MPUMIDI,OPLMIDI;
{$ELSE}
uses PStrings,DLL;
{$ENDIF}

{$IFDEF _DYNAMIC}
const MIDIHandle:word=256;

function MidiInit(Device:word;PathToDrivers:string):PMIDI;
var DLLName:string;
    MIDIObjName:pchar;
begin
 if MIDIHandle<>256 then Exit;  (* Already initialized *)
 PathToDrivers:=LTrimStr(RTrimStr(PathToDrivers));
 if (PathToDrivers<>'') and (PathToDrivers[Length(PathToDrivers)]<>'\') then
  PathToDrivers:=PathToDrivers+'\';
 case Device of
  _MPU401 : begin DLLName:='MPUMIDI.DLL'; MIDIObjName:='MIDI'; end;
  _AdLib  : begin DLLName:='OPLMIDI.DLL'; MIDIObjName:='OPL2MIDI'; end;
  _SB     : begin DLLName:='OPLMIDI.DLL'; MIDIObjName:='OPL2MIDI'; end;
  _SBPro  : begin DLLName:='OPLMIDI.DLL'; MIDIObjName:='OPL3MIDI'; end;
{$IFDEF _DEBUG}
  _Debug  : begin DLLName:='DBGMIDI.DLL'; MIDIObjName:='MIDI'; end;
{$ENDIF}
 else MidiInit:=nil;
 end;
 MIDIHandle:=dllLoad(PathToDrivers+DLLName);
 if dllError<>0 then begin
  MIDIHandle:=256;
  MidiInit:=nil;
 end
 else MidiInit:=dllGetObjectAddressByName(MIDIHandle,MIDIObjName);
end;

procedure MidiShutDown;
begin
 if MIDIHandle<>256 then begin
  dllFree(MIDIHandle);
  MIDIHandle:=256;
 end;
end;

{$ELSE}

function MidiInit(Device:word):PMIDI;
begin
 case Device of
  _MPU401 : MidiInit:=@MPUMIDI.MIDI;
  _AdLib  : MidiInit:=@OPLMIDI.OPL2MIDI;
  _SB     : MidiInit:=@OPLMIDI.OPL2MIDI;
  _SBPro  : MidiInit:=@OPLMIDI.OPL3MIDI;
{$IFDEF _DEBUG}
  _Debug  : MidiInit:=@DbgMIDI.MIDI;
{$ENDIF}
 else MidiInit:=nil;
 end;
end;

{$ENDIF}

end.
