(*****************************************************)
(* VRg MIDI Music System 1.12                        *)
(* MIDI device for OPL2/OPL3 FM-synthesis soundcards *)
(*  This one really sucks! Especially drums...       *)
(*  and volume control... and everything else.       *)
(*  So, have pity to your gentle ears and go         *)
(*  get yourself wavetable synthesizer :)            *)
(*                                                   *)
(* (C) 1998-1999 Virtual Research                    *)
(* Portionally based on code by Vladimir Arnost      *)
(* Unit version : 1.12                               *)
(* Last updated : 21.Nov.1999                        *)
(*****************************************************)

{$IFDEF _DYNAMIC}
 {$IFNDEF __TMT__}
  {$UNDEF _DYNAMIC}
 {$ENDIF}
{$ENDIF}

{$IFNDEF _DYNAMIC}
unit OPLMIDI;
{$ELSE}
program OPLMIDI;
{$ENDIF}

{$I DEF32.INC}
{$IFNDEF _32BIT}
 {$F+}
 {$C FIXED PRELOAD PERMANENT}
{$ENDIF}
{$I release.opt}

interface
uses VRMMSDef;

const VERSION='1.12';
      VersionInfo:longint=$00010102;

var OPL3MIDI,OPL2MIDI:TMIDI;

implementation
uses OPL {$IFDEF _DYNAMIC} ,DLL {$ENDIF};

type TMelodicBank=array[0..127] of TInstrument;
     PMelodicBank=^TMelodicBank;
     TDrumsBank=array[35..81] of TInstrument;
     PDrumsBank=^TDrumsBank;

     TChannel=record
      Instrument:TInstrument;
      Volume:byte;
      Pitch:byte;
      Left,Right:boolean;
      Sustain:boolean;
      Vibrato:boolean;
     end;

const DefaultMelodicBank:TMelodicBank=(
{$I MBANK4.INC}
);
      DefaultDrumsBank:TDrumsBank=(
{$I DBANK.INC}
);

      MelodicBankPtr:PMelodicBank=@DefaultMelodicBank;
      DrumsBankPtr:PDrumsBank=@DefaultDrumsBank;

      FIRST_REG_SET=false;
      SECOND_REG_SET=true;
      NOTE_ON=true;
      NOTE_OFF=false;
      NOT_ASSIGNED=16;

      Channels:array[0..15] of TChannel=(   (* Logical channels array *)
 (Instrument:($01,$11,$4F,$00,$F1,$D2,$51,$43,$00,$00,$06);Volume:64;
  Pitch:128;Left:true;Right:true;Sustain:false;Vibrato:false),
 (Instrument:($01,$11,$4F,$00,$F1,$D2,$51,$43,$00,$00,$06);Volume:64;
  Pitch:128;Left:true;Right:true;Sustain:false;Vibrato:false),
 (Instrument:($01,$11,$4F,$00,$F1,$D2,$51,$43,$00,$00,$06);Volume:64;
  Pitch:128;Left:true;Right:true;Sustain:false;Vibrato:false),
 (Instrument:($01,$11,$4F,$00,$F1,$D2,$51,$43,$00,$00,$06);Volume:64;
  Pitch:128;Left:true;Right:true;Sustain:false;Vibrato:false),
 (Instrument:($01,$11,$4F,$00,$F1,$D2,$51,$43,$00,$00,$06);Volume:64;
  Pitch:128;Left:true;Right:true;Sustain:false;Vibrato:false),
 (Instrument:($01,$11,$4F,$00,$F1,$D2,$51,$43,$00,$00,$06);Volume:64;
  Pitch:128;Left:true;Right:true;Sustain:false;Vibrato:false),
 (Instrument:($01,$11,$4F,$00,$F1,$D2,$51,$43,$00,$00,$06);Volume:64;
  Pitch:128;Left:true;Right:true;Sustain:false;Vibrato:false),
 (Instrument:($01,$11,$4F,$00,$F1,$D2,$51,$43,$00,$00,$06);Volume:64;
  Pitch:128;Left:true;Right:true;Sustain:false;Vibrato:false),
 (Instrument:($01,$11,$4F,$00,$F1,$D2,$51,$43,$00,$00,$06);Volume:64;
  Pitch:128;Left:true;Right:true;Sustain:false;Vibrato:false),
 (Instrument:($01,$11,$4F,$00,$F1,$D2,$51,$43,$00,$00,$06);Volume:64;
  Pitch:128;Left:true;Right:true;Sustain:false;Vibrato:false),
 (Instrument:($01,$11,$4F,$00,$F1,$D2,$51,$43,$00,$00,$06);Volume:64;
  Pitch:128;Left:true;Right:true;Sustain:false;Vibrato:false),
 (Instrument:($01,$11,$4F,$00,$F1,$D2,$51,$43,$00,$00,$06);Volume:64;
  Pitch:128;Left:true;Right:true;Sustain:false;Vibrato:false),
 (Instrument:($01,$11,$4F,$00,$F1,$D2,$51,$43,$00,$00,$06);Volume:64;
  Pitch:128;Left:true;Right:true;Sustain:false;Vibrato:false),
 (Instrument:($01,$11,$4F,$00,$F1,$D2,$51,$43,$00,$00,$06);Volume:64;
  Pitch:128;Left:true;Right:true;Sustain:false;Vibrato:false),
 (Instrument:($01,$11,$4F,$00,$F1,$D2,$51,$43,$00,$00,$06);Volume:64;
  Pitch:128;Left:true;Right:true;Sustain:false;Vibrato:false),
 (Instrument:($01,$11,$4F,$00,$F1,$D2,$51,$43,$00,$00,$06);Volume:64;
  Pitch:128;Left:true;Right:true;Sustain:false;Vibrato:false));

      NoteMap:array[0..127] of word=(   (* Note frequencies *)
   345,365,387,410,435,460,488,517,547,580,615,651,
   690,731,774,820,869,921,975,517,547,580,615,651,
   690,731,774,820,869,921,975,517,547,580,615,651,
   690,731,774,820,869,921,975,517,547,580,615,651,
   690,731,774,820,869,921,975,517,547,580,615,651,
   690,731,774,820,869,921,975,517,547,580,615,651,
   690,731,774,820,869,921,975,517,547,580,615,651,
   690,731,774,820,869,921,975,517,547,580,615,651,
   690,731,774,820,869,921,975,517,547,580,615,651,
   690,731,774,820,869,921,975,517,547,580,615,651,
   690,731,774,820,869,921,975,517);

      OctaveMap:array[0..127] of byte=(     (* Block numbers *)
   0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,1,1,1,1,1,
   1,1,1,1,1,1,1,2,2,2,2,2,
   2,2,2,2,2,2,2,3,3,3,3,3,
   3,3,3,3,3,3,3,4,4,4,4,4,
   4,4,4,4,4,4,4,5,5,5,5,5,
   5,5,5,5,5,5,5,6,6,6,6,6,
   6,6,6,6,6,6,6,7,7,7,7,7,
   7,7,7,7,7,7,7,8,8,8,8,8,
   8,8,8,8,8,8,8,9,9,9,9,9,
   9,9,9,9,9,9,9,10);

      PitchMap:array[0..255] of word=(
   29193,29219,29246,29272,29299,29325,29351,29378,
   29405,29431,29458,29484,29511,29538,29564,29591,
   29618,29644,29671,29698,29725,29752,29778,29805,
   29832,29859,29886,29913,29940,29967,29994,30021,
   30048,30076,30103,30130,30157,30184,30212,30239,
   30266,30293,30321,30348,30376,30403,30430,30458,
   30485,30513,30541,30568,30596,30623,30651,30679,
   30706,30734,30762,30790,30817,30845,30873,30901,
   30929,30957,30985,31013,31041,31069,31097,31125,
   31153,31181,31209,31237,31266,31294,31322,31350,
   31379,31407,31435,31464,31492,31521,31549,31578,
   31606,31635,31663,31692,31720,31749,31778,31806,
   31835,31864,31893,31921,31950,31979,32008,32037,
   32066,32095,32124,32153,32182,32211,32240,32269,
   32298,32327,32357,32386,32415,32444,32474,32503,
   32532,32562,32591,32620,32650,32679,32709,32738,
   32768,32798,32827,32857,32887,32916,32946,32976,
   33005,33035,33065,33095,33125,33155,33185,33215,
   33245,33275,33305,33335,33365,33395,33425,33455,
   33486,33516,33546,33576,33607,33637,33667,33698,
   33728,33759,33789,33820,33850,33881,33911,33942,
   33973,34003,34034,34065,34095,34126,34157,34188,
   34219,34250,34281,34312,34343,34374,34405,34436,
   34467,34498,34529,34560,34591,34623,34654,34685,
   34716,34748,34779,34811,34842,34874,34905,34937,
   34968,35000,35031,35063,35095,35126,35158,35190,
   35221,35253,35285,35317,35349,35381,35413,35445,
   35477,35509,35541,35573,35605,35637,35669,35702,
   35734,35766,35798,35831,35863,35895,35928,35960,
   35993,36025,36058,36090,36123,36155,36188,36221,
   36254,36286,36319,36352,36385,36417,36450,36483,
   36516,36549,36582,36615,36648,36681,36715,36748);

      VolumeMap:array[0..64] of byte=( (* Logarithmic volume scale *)
   63,53,47,42,39,36,34,32,30,28,
   27,26,25,23,22,21,21,20,19,18,
   17,17,16,15,15,14,14,13,12,12,
   11,11,11,10,10,9,9,8,8,8,7,7,7,
   6,6,6,5,5,5,4,4,4,3,3,3,3,2,2,
   2,2,1,1,1,1,0);


      MaxChannel:byte=8;        (* Maximal physical channel number *)

type TChannelAssignment=record
 Used:boolean;
 UseCount:word;
 LogicalChannel:byte;
 Note:byte;
 Freq:word;
 Octave:byte;
 Scaling:byte;
end;

    (* This array maps physical channels to logical. I mean,
       logical to physical. Ah, whatever :) *)
const ChannelAssignment:array[0..17] of TChannelAssignment=(
 (Used:false;UseCount:0;LogicalChannel:NOT_ASSIGNED;
  Note:128;Freq:512;Octave:1;Scaling:0),
 (Used:false;UseCount:0;LogicalChannel:NOT_ASSIGNED;
  Note:128;Freq:512;Octave:1;Scaling:0),
 (Used:false;UseCount:0;LogicalChannel:NOT_ASSIGNED;
  Note:128;Freq:512;Octave:1;Scaling:0),
 (Used:false;UseCount:0;LogicalChannel:NOT_ASSIGNED;
  Note:128;Freq:512;Octave:1;Scaling:0),
 (Used:false;UseCount:0;LogicalChannel:NOT_ASSIGNED;
  Note:128;Freq:512;Octave:1;Scaling:0),
 (Used:false;UseCount:0;LogicalChannel:NOT_ASSIGNED;
  Note:128;Freq:512;Octave:1;Scaling:0),
 (Used:false;UseCount:0;LogicalChannel:NOT_ASSIGNED;
  Note:128;Freq:512;Octave:1;Scaling:0),
 (Used:false;UseCount:0;LogicalChannel:NOT_ASSIGNED;
  Note:128;Freq:512;Octave:1;Scaling:0),
 (Used:false;UseCount:0;LogicalChannel:NOT_ASSIGNED;
  Note:128;Freq:512;Octave:1;Scaling:0),
 (Used:false;UseCount:0;LogicalChannel:NOT_ASSIGNED;
  Note:128;Freq:512;Octave:1;Scaling:0),
 (Used:false;UseCount:0;LogicalChannel:NOT_ASSIGNED;
  Note:128;Freq:512;Octave:1;Scaling:0),
 (Used:false;UseCount:0;LogicalChannel:NOT_ASSIGNED;
  Note:128;Freq:512;Octave:1;Scaling:0),
 (Used:false;UseCount:0;LogicalChannel:NOT_ASSIGNED;
  Note:128;Freq:512;Octave:1;Scaling:0),
 (Used:false;UseCount:0;LogicalChannel:NOT_ASSIGNED;
  Note:128;Freq:512;Octave:1;Scaling:0),
 (Used:false;UseCount:0;LogicalChannel:NOT_ASSIGNED;
  Note:128;Freq:512;Octave:1;Scaling:0),
 (Used:false;UseCount:0;LogicalChannel:NOT_ASSIGNED;
  Note:128;Freq:512;Octave:1;Scaling:0),
 (Used:false;UseCount:0;LogicalChannel:NOT_ASSIGNED;
  Note:128;Freq:512;Octave:1;Scaling:0),
 (Used:false;UseCount:0;LogicalChannel:NOT_ASSIGNED;
  Note:128;Freq:512;Octave:1;Scaling:0));

function OPL3InitDevice(Port:word):boolean;
var DetectionResult:byte;
begin
 OPL_IO_Addr:=Port;
 if oplDetect<>OPL3_STEREO then OPL3InitDevice:=false
  else OPL3InitDevice:=true;
 MaxChannel:=17;
end;

function OPL2InitDevice(Port:word):boolean;
var DetectionResult:byte;
begin
 OPL_IO_Addr:=Port;
 if oplDetect=OPL_NOT_DETECTED then OPL2InitDevice:=false
  else OPL2InitDevice:=true;
 oplDisableOPL3;
 MaxChannel:=8;
end;

procedure NoteOff(Channel,Note,Velocity:byte);forward;

function GetUnusedChannel:byte; {$IFNDEF _32BIT} near; {$ENDIF}
var i:byte;
    UnusedChannel:byte;
    MaxUseCount:word;
begin
 UnusedChannel:=NOT_ASSIGNED;
 for i:=0 to MaxChannel do
  if not ChannelAssignment[i].Used then begin
   UnusedChannel:=i;
   ChannelAssignment[i].Used:=true;
   Break;
  end
  else begin
   if ChannelAssignment[i].UseCount<65535 then
    Inc(ChannelAssignment[i].UseCount);
  end;
 if UnusedChannel=NOT_ASSIGNED then begin       (* No free channel found
                                                   so turn off one with
                                                   longest use time      *)
  MaxUseCount:=0;
  for i:=0 to MaxChannel do
   if ChannelAssignment[i].UseCount>MaxUseCount then begin
    MaxUseCount:=ChannelAssignment[i].UseCount;
    UnusedChannel:=i;
   end;
   NoteOff(ChannelAssignment[UnusedChannel].LogicalChannel,
           ChannelAssignment[UnusedChannel].Note,0);
   ChannelAssignment[UnusedChannel].Used:=true;
 end;
 GetUnusedChannel:=UnusedChannel;
end;

procedure ChangeMelodicBank(Bank:pointer);
begin
 MelodicBankPtr:=Bank;
end;

procedure ChangeDrumsBank(Bank:pointer);
begin
 DrumsBankPtr:=Bank;
end;

procedure NoteOn(Channel,Note,Velocity:byte);
var Freq:word;
    Octave:byte;
    CurrentInstrument:TInstrument;
    PhysicalChannel:byte;
begin
 if Velocity=0 then NoteOff(Channel,Note,Velocity) else begin
  PhysicalChannel:=GetUnusedChannel;
  ChannelAssignment[PhysicalChannel].LogicalChannel:=Channel;
  ChannelAssignment[PhysicalChannel].Note:=Note;

  (* Set frequency *)
  if Channel<>9 then begin
   CurrentInstrument:=Channels[Channel].Instrument;
   Octave:=OctaveMap[Note];
   Freq:=NoteMap[Note];
  end
  else begin
   (* Set percussion *)
   CurrentInstrument:=DrumsBankPtr^[Note];
   Octave:=OctaveMap[60];
   Freq:=NoteMap[60];
  end;
  ChannelAssignment[PhysicalChannel].Freq:=Freq;
  ChannelAssignment[PhysicalChannel].Octave:=Octave;
  ChannelAssignment[PhysicalChannel].Scaling:=CurrentInstrument[3] and $C0;

  (* Set Pitch *)
  if Channels[Channel].Pitch<>128 then begin
   Freq:=Freq*longint(PitchMap[Channels[Channel].Pitch]) shr 15;
   if Freq>1024 then begin Freq:=Freq shr 1; Inc(Octave); end;
  end;
  if Octave>7 then Octave:=7;

  (* Set volume *)
  CurrentInstrument[3]:=(CurrentInstrument[3] and $C0) or
   VolumeMap[((Velocity+1)*Channels[Channel].Volume) shr 7];

  (* Set sustain *)
  if Channels[Channel].Sustain then CurrentInstrument[1]:=
   CurrentInstrument[1] or 32;

  (* Set vibrato *)
  if Channels[Channel].Vibrato then CurrentInstrument[1]:=
   CurrentInstrument[1] or 64;

  (* Set note on *)
  if PhysicalChannel<=8 then begin
   oplSetInstrument(FIRST_REG_SET,PhysicalChannel,
   CurrentInstrument,Channels[Channel].Left,Channels[Channel].Right);
   oplSetNote(FIRST_REG_SET,PhysicalChannel,Freq,Octave,NOTE_ON)
  end
  else begin
   oplSetInstrument(SECOND_REG_SET,PhysicalChannel-9,
   CurrentInstrument,Channels[Channel].Left,Channels[Channel].Right);
   oplSetNote(SECOND_REG_SET,PhysicalChannel-9,Freq,Octave,NOTE_ON);
  end;
 end;
end;

procedure NoteOff(Channel,Note,Velocity:byte);
var i:byte;
begin
 for i:=0 to MaxChannel do
  if ChannelAssignment[i].Used and
     (ChannelAssignment[i].LogicalChannel=Channel) and
     (ChannelAssignment[i].Note=Note) then begin
   if i<=8 then
    oplSetNote(FIRST_REG_SET,i,ChannelAssignment[i].Freq,
               ChannelAssignment[i].Octave,NOTE_OFF)
   else
    oplSetNote(SECOND_REG_SET,i-9,ChannelAssignment[i].Freq,
               ChannelAssignment[i].Octave,NOTE_OFF);
   ChannelAssignment[i].Used:=false;
   ChannelAssignment[i].UseCount:=0;
   Break;
  end;
end;

procedure AllNotesOff(Channel:byte); {$IFNDEF _32BIT} near; {$ENDIF}
var i:byte;
begin
 for i:=0 to MaxChannel do
  if ChannelAssignment[i].Used and 
     (ChannelAssignment[i].LogicalChannel=Channel) then begin
   if i<=8 then
    oplSetNote(FIRST_REG_SET,i,ChannelAssignment[i].Freq,
               ChannelAssignment[i].Octave,NOTE_OFF)
   else
    oplSetNote(SECOND_REG_SET,i-9,ChannelAssignment[i].Freq,
               ChannelAssignment[i].Octave,NOTE_OFF);
   ChannelAssignment[i].Used:=false;
   ChannelAssignment[i].UseCount:=0;
  end;
end;

procedure KeyAfterTouch(Channel,Note,Velocity:byte);
var i:byte;
begin
 for i:=0 to MaxChannel do
  if ChannelAssignment[i].Used and 
     (ChannelAssignment[i].LogicalChannel=Channel) and
     (ChannelAssignment[i].Note=Note) then begin
   if i<=8 then 
    oplSetInsCharacteristic(FIRST_REG_SET,i,
     ChannelAssignment[i].Scaling or 
     VolumeMap[((Velocity+1)*Channels[Channel].Volume) shr 7],3,true,true)
   else 
    oplSetInsCharacteristic(SECOND_REG_SET,i,
     ChannelAssignment[i].Scaling or 
     VolumeMap[((Velocity+1)*Channels[Channel].Volume) shr 7],3,true,true);
   Break;
  end;
end;

procedure ChangeController(Channel,Controller,NewValue:byte);
begin
 case Controller of
  MODULATION_POT: 
   if NewValue<64 then Channels[Channel].Vibrato:=false
   else Channels[Channel].Vibrato:=true;
  SUSTAIN_PEDAL: 
   if NewValue<64 then Channels[Channel].Sustain:=false
   else Channels[Channel].Sustain:=true;
  VOLUME_SET:
   Channels[Channel].Volume:=(NewValue+1) shr 1;
  PAN_SET: begin
   if NewValue<56 then begin
    Channels[Channel].Left:=true;
    Channels[Channel].Right:=false;
   end
   else if NewValue>72 then begin
    Channels[Channel].Left:=false;
    Channels[Channel].Right:=true;
   end
   else begin
    Channels[Channel].Left:=true;
    Channels[Channel].Right:=true;
   end;
  end;
  ALL_SOUNDS_OFF: AllNotesOff(Channel);
  ALL_NOTES_OFF: AllNotesOff(Channel); 
  RESET_ALL: begin
   Channels[Channel].Sustain:=false;
   Channels[Channel].Vibrato:=false;
   Channels[Channel].Left:=true;
   Channels[Channel].Right:=true;
   Channels[Channel].Volume:=64;
   Channels[Channel].Pitch:=128;
  end;
 end;
end;

procedure PitchWheel(Channel:byte;Value:word);
begin
 Channels[Channel].Pitch:=Lo(Value) shl 1;
end;

procedure ChangePatch(Channel,Instrument:byte);
begin
 Channels[Channel].Instrument:=MelodicBankPtr^[Instrument];
end;

procedure ChannelAfterTouch(Channel,Velocity:byte);
var i:byte;
begin
 for i:=0 to MaxChannel do
  if ChannelAssignment[i].Used and 
     (ChannelAssignment[i].LogicalChannel=Channel) then begin
   if i<=8 then
    oplSetInsCharacteristic(FIRST_REG_SET,i,
     ChannelAssignment[i].Scaling or 
     VolumeMap[((Velocity+1)*Channels[Channel].Volume) shr 7],3,true,true)
   else 
    oplSetInsCharacteristic(SECOND_REG_SET,i,
     ChannelAssignment[i].Scaling or 
     VolumeMap[((Velocity+1)*Channels[Channel].Volume) shr 7],3,true,true);
  end;
end;

procedure ShutDownDevice;
var i:byte;
begin
 for i:=0 to 15 do begin
  ChangeController(i,RESET_ALL,0);
  AllNotesOff(i);
 end;
 oplReset;
end;

{$IFDEF _DYNAMIC}

const EXPORTED_OBJECTS=3;

      ExportTable:array[0..EXPORTED_OBJECTS] of TExportTableEntry=(
       (Name:'OPL2MIDI';ParmCount:0;Address:@OPL2MIDI),
       (Name:'OPL3MIDI';ParmCount:0;Address:@OPL3MIDI),
       (Name:'VersionInfo';ParmCount:0;Address:@VersionInfo),
       (Name:nil;ParmCount:0;Address:nil));

      ExportTableHeader:TExportTableHeader=(
       Signature:'%EXPORT%';
       Table:@ExportTable;
       DummyString:nil);

{$ENDIF}

begin
 @OPL3MIDI.InitDevice:=@OPL3InitDevice;
 @OPL3MIDI.ChangeMelodicBank:=@ChangeMelodicBank;
 @OPL3MIDI.ChangeDrumsBank:=@ChangeDrumsBank;
 @OPL3MIDI.NoteOn:=@NoteOn;
 @OPL3MIDI.NoteOff:=@NoteOff;
 @OPL3MIDI.KeyAfterTouch:=@KeyAfterTouch;
 @OPL3MIDI.ChangeController:=@ChangeController;
 @OPL3MIDI.PitchWheel:=@PitchWheel;
 @OPL3MIDI.ChangePatch:=@ChangePatch;
 @OPL3MIDI.ChannelAfterTouch:=@ChannelAfterTouch;
 @OPL3MIDI.ShutDownDevice:=@ShutDownDevice;

 OPL2MIDI:=OPL3MIDI;
 @OPL2MIDI.InitDevice:=@OPL2InitDevice;

{$IFDEF _DYNAMIC}
 ExportTableHeader.DummyString:=
  #13#10'Dynamic link MIDI driver for OPL2/OPL3 FM-synthesizer'+
  #13#10'Version '+VERSION+
  #13#10'Virtual Research independent group production, 1998-1999';
{$ENDIF}

end.
