(************************************************)
(* Some functions for Pascal-style strings      *)
(* Version 3.11                                 *)
(* Last updated : 09.Jul.1999                   *)
(* (C)oded by Asp, 1998-1999                    *)
(************************************************)

unit pstrings;
{$I DEF32.INC}
{$I release.opt}

interface

const NL=#13+#10;
      NewLine=#13+#10;
      CRLF=#13+#10;

function UpCaseStr(S:string):string;
        (* Converts string to upper case *)
function LoCaseStr(S:string):string;
        (* Converts string to lower case *)
function RightStr(S:string;L:byte):string;
        (* Returns L rightmost characters of S *)
function LeftStr(S:string;L:byte):string;
        (* Returns L leftmost characters of S *)
function LTrimStr(S:string):string;
        (* Deletes space characters from string begin *)
function RTrimStr(S:string):string;
        (* Deletes space characters from string end *)
function StrStr(C:char;L:byte):string;
        (* Returns string of L characters "C" *)
function HexStr(N:word):string;
        (* Converts N to hexadecimal string *)
function DHexStr(N:longint):string;
        (* Converts N to hexadecimal string *)
procedure StrToASCIIZ(S:string;var A:array of char);
        (* Converts pascal-style string to ASCIIZ *)
procedure ASCIIZToStr(A:array of char;var S:string);
        (* Converts ASCIIZ to pascal-style string *)

implementation

function UpCaseStr(S:string):string;assembler;
asm
{$IFNDEF _32BIT}
 push ds
 cld
 lds si,S
 les di,@Result
 lodsb
 stosb
 xor ah,ah
 xchg ax,cx
 jcxz @3
@1:
 lodsb
 cmp al,'a'
 jb @2
 cmp al,'z'
 ja @2
 sub al,32
@2:
 stosb
 loop @1
@3:
 pop ds
{$ELSE}
 cld
 mov esi,S
 mov edi,@Result
 xor eax,eax
 lodsb
 stosb
 xor ah,ah
 xchg eax,ecx
 jecxz @3
@1:
 lodsb
 cmp al,'a'
 jb @2
 cmp al,'z'
 ja @2
 sub al,32
@2:
 stosb
 loop @1
@3:
{$ENDIF}
end;

function LoCaseStr(S:string):string;assembler;
asm
{$IFNDEF _32BIT}
 push ds
 cld
 lds si,S
 les di,@Result
 lodsb
 stosb
 xor ah,ah
 xchg ax,cx
 jcxz @3
@1:
 lodsb
 cmp al,'A'
 jb @2
 cmp al,'Z'
 ja @2
 add al,32
@2:
 stosb
 loop @1
@3:
 pop ds
{$ELSE}
 cld
 mov esi,S
 mov edi,@Result
 xor eax,eax
 lodsb
 stosb
 xor ah,ah
 xchg eax,ecx
 jecxz @3
@1:
 lodsb
 cmp al,'A'
 jb @2
 cmp al,'Z'
 ja @2
 add al,32
@2:
 stosb
 loop @1
@3:
{$ENDIF}
end;

function LeftStr(S:string;L:byte):string;assembler;
asm
{$IFNDEF _32BIT}
 push ds
 cld
 xor ax,ax
 lds si,S
 les di,@Result
 mov es:[di],al
 lodsb
 xor al,0
 jz @exit
 cmp al,L
 js @1
 mov al,L
@1:
 stosb
 xor ch,ch
 mov cl,al
 rep movsb
@exit:
 pop ds
{$ELSE}
 cld
 xor eax,eax
 mov esi,S
 mov edi,@Result
 mov [edi],al
 lodsb
 xor al,0
 jz @exit
 cmp al,L
 js @1
 mov al,L
@1:
 stosb
 xor ecx,ecx
 mov cl,al
 rep movsb
@exit:
{$ENDIF}
end;

function RightStr(S:string;L:byte):string;assembler;
asm
{$IFNDEF _32BIT}
 push ds
 std
 xor ax,ax
 xor bx,bx
 lds si,S
 les di,@Result
 mov es:[di],al
 mov al,ds:[si]
 xor al,0
 jz @exit
 mov bl,al
 cmp al,L
 js @1
 mov al,L
@1:
 mov es:[di],al
 mov cx,ax
 add si,bx
 add di,ax
 rep movsb
@exit:
 cld
 pop ds
{$ELSE}
 std
 xor eax,eax
 xor ebx,ebx
 mov esi,S
 mov edi,@Result
 mov [edi],al
 mov al,[esi]
 xor al,0
 jz @exit
 mov bl,al
 cmp al,L
 js @1
 mov al,L
@1:
 mov [edi],al
 mov ecx,eax
 add esi,ebx
 add edi,eax
 rep movsb
@exit:
 cld
{$ENDIF}
end;

function LTrimStr(S:string):string;assembler;
asm
{$IFNDEF _32BIT}
 push ds
 cld
 lds si,S
 les di,@Result
 lodsb
 xor cx,cx
 mov cl,al
 jcxz @3
@1:
 lodsb
 cmp al,32
 jne @2
 dec cl
 jcxz @3
 jmp @1
@2:
 cmp al,9
 jne @3
 dec cl
 jcxz @3
 jmp @1
@3:
 mov al,cl
 stosb
 dec si
 rep movsb
 pop ds
{$ELSE}
 cld
 mov esi,S
 mov edi,@Result
 lodsb
 xor ecx,ecx
 mov cl,al
 jecxz @3
@1:
 lodsb
 cmp al,32
 jne @2
 dec cl
 jecxz @3
 jmp @1
@2:
 cmp al,9
 jne @3
 dec cl
 jecxz @3
 jmp @1
@3:
 mov al,cl
 stosb
 dec esi
 rep movsb
{$ENDIF}
end;

function RTrimStr(S:string):string;assembler;
asm
{$IFNDEF _32BIT}
 push ds
 cld
 lds si,S
 les di,@Result
 lodsb
 xor cx,cx
 mov cl,al
 jcxz @3
 mov bx,si
 add si,cx
 dec si
 std
@1:
 lodsb
 cmp al,32
 jne @2
 dec cl
 jcxz @3
 jmp @1
@2:
 cmp al,9
 jne @3
 dec cl
 jcxz @3
 jmp @1
@3:
 cld
 mov al,cl
 stosb
 mov si,bx
 rep movsb
 pop ds
{$ELSE}
 cld
 mov esi,S
 mov edi,@Result
 lodsb
 xor ecx,ecx
 mov cl,al
 jecxz @3
 mov ebx,esi
 add esi,ecx
 dec esi
 std
@1:
 lodsb
 cmp al,32
 jne @2
 dec cl
 jecxz @3
 jmp @1
@2:
 cmp al,9
 jne @3
 dec cl
 jecxz @3
 jmp @1
@3:
 cld
 mov al,cl
 stosb
 mov esi,ebx
 rep movsb
{$ENDIF}
end;

function StrStr(C:char;L:byte):string;assembler;
asm
{$IFNDEF _32BIT}
 cld
 les di,@Result
 mov al,L
 stosb
 xor ch,ch
 mov cl,L
 mov al,C
 rep stosb
{$ELSE}
 cld
 mov edi,@Result
 mov al,L
 stosb
 xor ecx,ecx
 mov cl,L
 mov al,C
 rep stosb
{$ENDIF}
end;

function HexStr(N:word):string;
const HexDigits:array[0..15] of char=
      ('0','1','2','3','4','5','6','7',
       '8','9','A','B','C','D','E','F');
var i:byte;
    s:string[4];
begin
 s[0]:=#4;
 for i:=0 to 3 do
  s[i+1]:=HexDigits[(N and ($F000 shr (i shl 2))) shr ((3-i) shl 2)];
 HexStr:=s;
end;

function DHexStr(N:longint):string;
type DoubleWord=record
 LoWord:word;
 HiWord:word;
end;
begin
 DHexStr:=HexStr(DoubleWord(N).HiWord)+HexStr(DoubleWord(N).LoWord);
end;

procedure StrToASCIIZ(S:string;var A:array of char);
var i:byte;
begin
 for i:=0 to Length(S)-1 do A[i]:=S[i+1];
 A[Length(S)]:=#0;
end;

procedure ASCIIZToStr(A:array of char;var S:string);
var i:byte;
begin
 for i:=0 to 254 do 
  if A[i]<>#0 then S[i+1]:=A[i] else Break;
 S[0]:=Chr(i);
end;

end.


