(******************************************)
(* VRg MIDI Music System 1.12             *)
(* Global definitions and constants       *)
(* (C) 1998-1999 Virtual Research         *)
(* Unit version : 1.12                    *)
(* Last updated : 21.Nov.1999             *)
(******************************************)

unit VRMMSDef;
{$I DEF32.INC}
{$I release.opt}

interface

const Version='1.12';            (* Product version *)
function Copyleft_Id:string;     (* Product autority information *)


    (* Procedure types for MIDI driver structure *)

type    TInitDevice=function(Port:word):boolean;
        TChangeMelodicBank=procedure(NewBank:pointer);
        TChangeDrumsBank=procedure(NewBank:pointer);
        TNoteOn=procedure(Channel,Note,Velocity:byte);
        TNoteOff=procedure(Channel,Note,Velocity:byte);
        TKeyAfterTouch=procedure(Channel,Note,Velocity:byte);
        TChangeController=procedure(Channel,Controller,NewValue:byte);
        TPitchWheel=procedure(Channel:byte;Value:word);
        TChangePatch=procedure(Channel,Instrument:byte);
        TChannelAfterTouch=procedure(Channel,Velocity:byte);
        TShutDownDevice=procedure;


    (* MIDI driver structure *)

type PMIDI=^TMIDI;
     TMIDI=record
 InitDevice:TInitDevice;
 ChangeMelodicBank:TChangeMelodicBank;
 ChangeDrumsBank:TChangeDrumsBank;
 NoteOn:TNoteOn;
 NoteOff:TNoteOff;
 KeyAfterTouch:TKeyAfterTouch;
 ChangeController:TChangeController;
 PitchWheel:TPitchWheel;
 ChangePatch:TChangePatch;
 ChannelAfterTouch:TChannelAfterTouch;
 ShutDownDevice:TShutDownDevice;
end;

const _MPU401=0;        (* MPU401-based General MIDI device *)
      _AdLib=1;         (* OPL2 synthesizer, mono *)
      _SB=2;            (* OPL2 synthesizer, mono *)
      _SBPro=3;         (* OPL3 synthesizer, stereo *)
      _Debug=4;         (* MIDI stream dumper *)

      MAX_ERRORS=6;

      NO_ERROR=0;
      DEVICE_UNAVAILABLE=1;
      DEVICE_INIT_ERROR=2;
      INVALID_SEQ_FORMAT=3;
      LOAD_ERROR=4;
      NOT_ENOUGH_MEMORY=5;
      SEQ_TOO_LARGE=6;

      ErrorMsg:array[0..MAX_ERRORS] of pchar=
               ('Operation successful',
                'MIDI device unavailable',
                'MIDI device initialization error',
                'Invalid MIDI sequence format',
                'File load error',
                'Not enough memory',
                'Sequence too large');

{$I GMEVENTS.INC}
{$I GMCONTRL.INC}
{$I GMNAMES.INC}

implementation

var Copyleft:string;

function Copyleft_Id:string;
begin
 Copyleft_Id:=Copyleft;
end;

begin
 Copyleft:=#13+#10+' VRg MIDI Music System v. '+Version+#13+#10+
  ' Virtual Research independent group production (C) 1998-1999'+#13+#10;
end.
